-- ’

-- BuildSomething_Sow
-- BuildSomething_Science
-- BuildSomething_Port
-- BuildSomething_Buy_Elixir
-- BuildSomething_Tower


BuildSomething_Sow = room {
    nam = function (s)
        p ('Year '..Year..'. Education.');
    end,
    pic = 'images/labour.png',
    enter = function (s)
        if not ( (Year>=3) and (not isSow) and (Corn.now>1000) ) then
            return walk (BuildSomething_Science);
        end
    end,
    dsc = function (s)
        p ('^After some years of rule, you understand that your peasants absolutely don’t know neither how to plow nor how to sow.^You found experienced landowner. He is ready to teach your people.^Landowner request for his service 1000 bushels of grain.');
        p ('^Now you have in your granaries: ', Corn.now, ' bushels.');
        p ('^Will you teach your people?');
    end,
    obj = { vway('1', '{Yes}^', 'BuildSomething_Sow_ready'),
            vway('2', '{No}', 'BuildSomething_Science') },
};


BuildSomething_Sow_ready = room {
    nam = 'Education is over',
    pic = 'images/labour.png',
    entered = function (s)
        Corn.deal = -1000;
        Corn.now = Corn.now + Corn.deal;
        isSow = true;
    end,
    dsc = function (s)
        return 'Now your nationals know how to work the land!';
    end,
    obj = { vway('1', '{Next}^', 'BuildSomething_Science') },
};


BuildSomething_Science = room {
--    nam = 'BuildSomething_Science',
    nam = function (s)
        p ('Year '..Year..'. Building of Royal Academy.');
    end,
    pic = 'images/academy.png',
    enter = function (s)
        if not ( (Year>=10) and (not isScience) and (Corn.now>10000) ) then
            return walk (BuildSomething_Port);
        end
    end,
    dsc = function (s)
        p ('^To lighten your life and not to remain in stone age, it’s necessary to develop science. For a start it’ll be good to build Royal Academy, where you will can carry out different researches and teach your peasants and their children.');
        p ('^You need 10000 bushels of grain to build Royal Academy.');
        p ('^Now in your granaries: ', Corn.now, ' bushels.');
        p ('^Do you want to build Royal Academy?');
    end,
    obj = { vway('1', '{Yes}^', 'BuildSomething_Science_ready'),
            vway('2', '{No}', 'BuildSomething_Port') },
};


BuildSomething_Science_ready = room {
    nam = 'Royal Academy builded',
    pic = 'images/academy.png',
    entered = function (s)
        Corn.deal = -10000;
        Corn.now = Corn.now + Corn.deal;
        isScience = true;
    end,
    dsc = function (s)
        return 'You have built Royal Academy! Now your nationals can teach some science.';
    end,
    obj = { vway('1', '{Next}^', 'BuildSomething_Port') },
};


BuildSomething_Port = room {
    nam = function (s)
        p ('Year '..Year..'. Port building.');
    end,
    pic = 'images/port.png',
    enter = function (s)
        if not ( (Year>=20) and (not isPort) and (isScience) and (Corn.now>50000) ) then
            return walk (BuildSomething_Buy_Elixir);
        end
    end,
    dsc = function (s)
        p ('^For fast expand of your borders, it’s necessary to strengthen your position not only on land, but on the sea also. You should build port.');
        p ('^Having your own ships, you could be able to attack and pillage other commercial ships.');
        p ('^You need 50000 bushels of grain to build port.');
        p ('^Now in your granaries: ', Corn.now, ' bushels.');
        p ('^Do you want to build port?');
    end,
    obj = { vway('1', '{Yes}^', 'BuildSomething_Port_ready'),
            vway('2', '{No}', 'BuildSomething_Buy_Elixir') },
};


BuildSomething_Port_ready = room {
    nam = 'Port builded',
    pic = 'images/port.png',
    entered = function (s)
        Corn.deal = -50000;
        Corn.now = Corn.now + Corn.deal;
        isPort = true;
    end,
    dsc = function (s)
        return 'You have build port! Now you can attack other ships.';
    end,
    obj = { vway('1', '{Next}^', 'BuildSomething_Buy_Elixir') },
};


BuildSomething_Buy_Elixir = room {
--    nam = 'BuildSomething_Buy_Elixir',
    nam = function (s)
        p ('Year '..Year..'. Elixir of Long Life.');
    end,
    pic = 'images/graveyard.png',
    enter = function (s)
        if not ( (Year>60) and (Corn.now >= 100000) and (not LongLife) ) then
            return walk (BuildSomething_Tower);
        end
    end,
    dsc = function (s)
        p ('You have enough of grain to buy Elixir of Long Life.^Would you like to prolong your life? Elixir of Long Life will cost you 100000 bushels of grain.');
        p ('^Now in your granaries: ', Corn.now, ' bushels.');
        p ('^Do you want to buy Elixir of Long Life?');
    end,
    obj = { vway('1', '{Buy Elixir of Long Life}^', 'BuildSomething_Buy_Elixir_ready'),
            vway('2', '{I’ll decide that later}', 'BuildSomething_Tower') },
};


BuildSomething_Buy_Elixir_ready = room {
    nam = 'You purchased an Elixir of Long Life',
    pic = 'images/main.png',
    entered = function (s)
        LongLife = true;
        Corn.deal = Corn.deal - 100000;
        Corn.now = Corn.now - 100000;
    end,
    dsc = function (s)
        return 'You purchased an Elixir of Long Life and increased your longevity!';
    end,
    obj = { vway('1', '{Next}^', 'BuildSomething_Tower') },
};


BuildSomething_Tower = room {
--    nam = 'BuildSomething_Tower',
    nam = function (s)
        p ('Year '..Year..'. Building of Tower of Light.');
    end,
    pic = 'images/tower.png',
    enter = function (s)
        if ( (isTower) or not ( (Year<MegaMonster) and (Year>=85) and (Corn.now>250000) ) ) then
            return walk (main_cycle);
        end
    end,
    dsc = function (s)
        p ('Army of Darkness is approaching! But you have strength now. Survivor, you recieve 5 years ago, sayd that only Tower of Light could reduce onslaught of Darkness forces. By prior calculations, you will need 250000 bushels of grain to build Tower of Light.');
        p ('^Now in your granaries: ', Corn.now, ' bushels.');
        p ('^Do you want to buy Tower of Light?');
    end,
    obj = { vway('1', '{Start building}^', 'BuildSomething_Tower_ready'),
            vway('2', '{There is no need to rush, let’s wait for a while}', 'main_cycle') },
};


BuildSomething_Tower_ready = room {
    nam = 'You have built Tower of Light',
    pic = 'images/tower.png',
    entered = function (s)
        Corn.deal = -250000;
        Corn.now = Corn.now + Corn.deal;
        isTower = true;
    end,
    dsc = function (s)
        return 'You have built Tower of Light.';
    end,
    obj = { vway('1', '{Next}^', 'main_cycle') },
};

