require 'input'
require 'sprites'
require 'object'
require 'para'
require 'xact'
require 'dash'

dofile('types.lua');
dofile('shownews_eng.lua');
dofile('buildsomething_eng.lua');
dofile('buy_and_sell_land_eng.lua');
dofile('eat_eng.lua');
dofile('sow_eng.lua');
dofile('science_eng.lua');
dofile('port_eng.lua');
dofile('showinventions_eng.lua');
dofile('checkforwar_eng.lua');
dofile('war_eng.lua');

game.codepage="UTF-8"
game.dsc = [[Команды:^
    look(или просто ввод), act <на что> (или просто на что), use <что> [на что], go <куда>,^
    back, inv, way, obj, quit, save <fname>, load <fname>. Работает автодополнение по табуляции.^^]];


function init()
    cur = sprite.load('images/cursor.gif');
    local w,h = sprite.size(cur);
    local yy = sprite.font_scaled_size(h);
    cur2 = sprite.scale(cur, 1, yy/h);
    sprite.free(cur);
    cur = cur2;
    input.cursor=img(cur);
end

vvod = inp('inp', 'Input number: ', '');



main = room {
    nam = '«Kingdom of Grain»',
    pic = 'images/title.png',
    enter = function (s)
        set_music('music/ballada.mod');
    end,
    dsc = function (s)
        p 'This game is one of the first (or even first of all) economic computer game. First version of game is called «The Sumer Game». Dug Daiment wrote it at 1968 in FOCAL at DEC PDP-8.^Later David Ahl extend game capabilities, implemented it in BASIC. He called game «Hammurabi». The game source code he publish in «BASIC Computer Games».^Later on game has several more incarnations. One of them is «Kingdom of Grain» for ZX Spectrum (1992).^At 2005-2008 Parfenov Alex (Парфёнов Алексей) (alkatrazstudio@yandex.ru), wrote game «Kingdom 3», which based on «Hammurabi» code. He wrote it in Pascal, and even more extend game possibilities. He release game source code under GPL license.^Let me introduce new version of game. This game code is based on Parfenov Alex code. Images is taken from ZX Spectrum version, an artist — Belousov Alexander (Белоусов Александр).^Music — ballada by xtd / union (cia).';
        p '^^Remake for INSTEAD: Vadim V. Balashoff (Вадим В. Балашов), vvb.backup@rambler.ru';
        p '^Version 0.9.3 beta (31.08.2012).';
    end,
    obj = { --vway("1", "{Об авторах}^", 'about'),
            vway('2', '{Instruction}^', 'instruction'),
            vway('4', '{Start game}', 'initialization') },
};


instruction = room {
    nam = 'Instructions',
--    pic = 'images/instructions.png',
--    enter = function (s)
--        set_music('music/instructions.ogg');
--    end,
    dsc = function(s)
        return 'This is text game, so there no need in any detailed explanations. Just answer on questions on the screen, guided on your logic and your life experience.^^You are the monarch of ancient agrarian country somewhere in the middle of Europe.^Kingdon lands are fertile, peasants are happy, but there is a problem: your neighbours are envious, as always. But in spite of it you must provide prospere of your country and even try to expand your estates.^This task is not easy, as it seems at first sight, becouse your opponent is a keen computer programm. Programm send at you kingdom various misfortunes: from cholera and plague to locust and rats invasions. In addition, your enemies do not waste the time, trying to obtain one or another piece of your estates.^At your disposal there are three indexes, which you can deal with in depending on situation: population, land and grain. For example, to defend yourself from enemies, you can hire mercenaries, but it cost you some.^So, you have to decide: or give part of your grain and make your nationals to starve, or pay by land, what may threat shortage of grain and starving in the end.^So you have to manoeuvre constantly between wishful and possible, not forgetting what in any circumstances you must keep your crown, or othersie...';
    end,
    obj = { vway('1', '{Back to main menu}', 'main') },
};


initialization = room {
    nam = 'Welcome to Kingdom of Grain!',
--    pic = 'images/title.png',
    enter = function (s)
--        Initialization
          Year = 0;
          LongLife = false;
          isScience = false;
          isPort = false;
          isPortShow = false;
          People.total = 100;
          Corn.total = 10000;
          Corn.yield = 5;
          Land.total = 1000;
          People.now = 100;
          Corn.now = Corn.total;
          Corn.yield = 5;
          Land.now = Land.total;
          MegaMonster = 128;
    end,
    dsc = function (s)
        return 'On a magnificent coronation ceremony you have been charge to swear solemnly:^^«I, undersigned King, engage myself to following obligations:^- To rule my kingdom sober only;^- In a case of war to guard my people,^- from anyone to it’s possibilities, from everyone to it’s needs;^...»^There were some more lines in small font, but you’d like to seat on your throne so badly, that you sign it all without reading...^^Well, let’s start!';
    end,
    obj = { vway('1', '{Next}', 'main_cycle') },
--    obj = { vway('1', '{Далее}', 'ShowNews') },
};


-- instead version: room sequences
-- ===============================
-- main_cycle
-- ShowBuyLandDialog
-- ShowSellLandDialog
-- ShowEatDialog
-- ShowSowDialog
-- ShowScienceDialog
-- ShowShipBuildDialog
-- ShowPortDialog
-- ShowNews
--   ShowNewsDeal
--   ShowNewsIgo
-- ShowNewInventions
-- CheckForWar
--   ShowPeaceTalkDialog
--     ShowWarDeclareDialog
--       ShowWarDeclareDialog_2
--     GoWar
--     ...
--       EndWar
-- BuildSomething_Sow
-- BuildSomething_Science
-- BuildSomething_Port
-- BuildSomething_Buy_Elixir
-- BuildSomething_Tower
--


main_cycle = room {
--    nam = '«KoG» Main Cycle',
    nam = function (s)
        p ('Year '..Year..'. Results.');
    end,
--    pic = function (s)
--        return 'images/main.png';
--    end,
    enter = function (s)
        NewYear ();
        if ( ShowGameEnd() ) then
            pclr();
            walk (Game_Over);
            return;
        end
    end,
    dsc = function (s)
--        return 'main_cycle';
--====main_cycle====
--  repeat
        pn (imgr 'images/main.png');
        -- Population report
        p ('^Population at the beginning of year: ', People.total, ' man.');
        p ('^Was born: ', People.born, ' man.');
        p ('^Had died from hunger: ', People.hunger, ' man.');
        p ('^Had died from disease: ', People.illness, ' man.');
        p ('^Had died in battles: ', People.war, ' man.');
        p ('^Had commit suicide: ', People.suicide, ' man.');
        p ('^Thiefs: ', People.thiefs, ' man.');
        p ('^In port: ', People.port, ' man.');
        p ('^Sailing: ', People.sail, ' man.');
        p ('^Migration: ', People.balance, ' man.');
        p ('^Total population: ', People.now, ' man.');

        -- Land report
        p ('^^Land at the beginning of year: ', Land.total, ' acres.');
        p ('^Purchased/Sold: ', Land.corn, ' acres.');
        p ('^Because of war: ', Land.war, ' acres.');
        p ('^Stolen: ', Land.thiefs, ' acres.');
        p ('^Spoiled: ', Land.spoiled, ' acres.');
        p ('^Joined: ', Land.bonus, ' acres.');
        p ('^Total land: ', Land.now, ' acres.');

        -- Grain report
        p ('^^Grain at the beginning of year: ', Corn.total, ' bushels.');
        p ('^Spended on seeds: ', Corn.seed, ' bushels.');
        p ('^Harvest: ', Corn.harvest, ' bushels.');
        if (Corn.land >= 0) then
            p ('^Gained from selling land: ', Corn.land, ' bushels.');
        else
            p ('^Payed for purchasing land: ', Corn.land, ' bushels.');
        end
        p ('^Spended on building ships: ', Corn.ships, ' bushels.');
        p ('^Eaten: ', Corn.food, ' bushels.');
        p ('^Because of war: ', Corn.war, ' bushels.');
        p ('^Stolen: ', Corn.thiefs, ' bushels.');
        p ('^Eaten by rats: ', Corn.rats, ' bushels.');
        p ('^Mercenaries fee: ', Corn.fee, ' bushels.');
        p ('^Scientists fee: ', Corn.science, ' bushels.');
        p ('^Spoiled: ', Corn.spoiled, ' bushels.');
        p ('^Gained: ', Corn.bonus, ' bushels.');
        p ('^Debit/profit from deal: ', Corn.deal, ' bushels.');
        p ('^Planned productivity: ', Corn.yield, ' bushel/acre.');
        p ('^Total grain: ', Corn.now, ' bushels.');

        -- Ships report
        if isPort then
            p ('^^Ships at the beginning of year: ', Ships.total, ' ships.');
            p ('^Builded: ', Ships.build, ' ships.');
            p ('^Becouse of war: ', Ships.war, ' ships.');
            p ('^Sailing: ', Ships.sail, ' ships.');
            p ('^Arrived/departed: ', Ships.port, ' ships.');
            p ('^Total ships: ', Ships.now, ' ships.');
        end

        -- Research report
        if isScience then
            p ('^^Researches:');
            p ('^Population: ', Science.people, ' level.');
            p ('^Land: ', Science.land, ' level.');
            p ('^Grain: ', Science.corn, ' level.');
            p ('^Ships: ', Science.ships, ' level.');
            p ('^Military: ', Science.war, ' level.');
            p ('^Market: ', Science.buy, ' level.');
            p ('^Policy: ', Science.policy, ' level.');
            p ('^Medicine: ', Science.medicine, ' level.');
        end

        -- Rest information
        p ('^^Foreign/Inner policy:');
        p ('^Rating of kingdom: ', Rating, ' points.');
        p ('^Yoke: ', math.floor (Yoke), ' %');

        -- Epidemic
        if ( (Epidemy.bugs>0) or (Epidemy.radiation>0) or (Epidemy.plague>0) or (Epidemy.igo>0) ) then
            p ('^^Epidemic:');
        end
        if (Epidemy.bugs > 0) then
            p ('^Locust invasion. Years till ending: ', Epidemy.bugs);
        end
        if (Epidemy.radiation > 0) then
            p ('^Radiation. Years till ending: ', Epidemy.radiation);
        end
        if (Epidemy.plague > 0) then
            p ('^Plague. Years till ending: ', Epidemy.plague);
        end
        if (Epidemy.igo > 0) then
            p ('^Tribute payment: Years till ending: ', Epidemy.igo);
        end

        events = 0;
        -- Recommendations
        p ('^^Recommendations:');
        if ( (isScience) and ( Science.count < 50) ) then
            p ('^Spend more grain on research.');
            events = events + 1;
        end
        if ( (isPort) and ((Ships.sail + Ships.now) < 70) ) then
            p ('^Build more ships.');
            events = events + 1;
        end
        if ( (Year > 35) and (People.now < (Year*2.5) ) ) then
            p ('^Increase population level.');
            events = events + 1;
        end
        if ( (math.floor(Land.now) < People.now*5) ) then
            p ('^Buy more land. People have no place to live!');
            events = events + 1;
        end
        if ( (Year>3) and (not isSow) ) then
            p ('^Teach your people to sow wheat!');
            events = events + 1;
            if (Corn.now < 1000) then
                p (' You need 1000 bushels of grain for teaching!');
            end
        end
        if ( (Year > 10) and (not isScience)) then
            p ('^Build an academy!');
            events = events + 1;
            if (Corn.now < 10000) then
                p (' You need 10000 bushels of grain for building!');
            end
        end
        if ( (Year > 25) and (not isPort) and (isScience) ) then
            p ('^Build a port!');
            events = events + 1;
            if (Corn.now < 50000) then
                p (' You need 50000 bushels of grain for building!');
            end
        end
        if (Yoke > 60)then
            p ('^People on the edge of revolution!');
            events = events + 1;
        end
        if (People.now < 10)then
            p ('^You have too little population!');
            events = events + 1;
        end
        if ( (Year > 70) and (not LongLife)) then
            p ('^You should bauy an Elixir of Long Life!');
            events = events + 1;
            if (Corn.now < 100000) then
                p (' You need 100000 bushels of grain to buy it!');
            end
        end
        if (People.hunger > 0) then
            p '^People are dying from hunger in your kingdom! Give more grain for eating!';
            events = events + 1;
        end
        if (events == 0) then
            p '^Your current style of ruling kingdom is not a cause for blaming. Continue on the same lines!';
        end
    end,
    obj = { vway('1', '{Next}', 'ShowBuyLandDialog') },
    exit = function (s)
        Statistics.starved_to_death = Statistics.starved_to_death + People.hunger;
        People.born = 0;
        People.hunger = 0;
        People.illness = 0;
        People.suicide = 0;
        People.war = 0;
        People.thiefs = 0;
        People.port = 0;
        People.balance = 0;
        People.total = People.now;
        Land.corn = 0;
        Land.war = 0;
        Land.thiefs = 0;
        Land.spoiled = 0;
        Land.bonus = 0;
        Land.total = Land.now;
        Corn.seed = 0;
        Corn.harvest = 0;
        Corn.land = 0;
        Corn.ships = 0;
        Corn.food = 0;
        Corn.war = 0;
        Corn.thiefs = 0;
        Corn.rats = 0;
        Corn.fee = 0;
        Corn.science = 0;
        Corn.spoiled = 0;
        Corn.bonus = 0;
        Corn.deal = 0;
        Corn.total = Corn.now;
        Ships.build = 0;
        Ships.war = 0;
        Ships.port = 0;
        Ships.total = Ships.now;
    end,
};





function NewYear ()
-- ========== NewYear ===========
    Year = Year + 1;
--    Statistic counting
    if (Epidemy.plague > 0) then
        Epidemy.plague = Epidemy.plague - 1;
    end

    -- Corn
    if (Epidemy.bugs == 0) then
        tmp = math.random (3);
        Corn.yield = tmp + 2 + math.floor (Science.land/3);
    else
        Corn.yield = 0;
    end
    if not isSow then
        Corn.yield = 0;
    end
    Corn.now = Corn.now + Corn.harvest;
    Corn.now = Corn.now + Corn.bonus;
    Corn.now = Corn.now - Corn.rats;
    Corn.now = Corn.now - Corn.spoiled;
    Corn.now = Corn.now - Corn.thiefs;


    tmp = math.random (25);
    Science.integrity = Science.integrity - tmp;
    tmp = math.random (10);
    Yoke = Yoke + tmp - 5;
    if (Yoke < 0) then
        Yoke = 0;
    end
    if (Year > 10) then
        Rating = math.floor (People.now/(Year*2.5)+(Land.now*27+Corn.now)/(Year*100)+(Ships.port+Ships.sail)/(Year/10)+(Science.count)/(Year*0.8));
    else
        Rating = 0;
    end

    -- Land
    Land.now = Land.now + Land.bonus;
    Land.now = Land.now - Land.spoiled;
    Land.now = Land.now - Land.thiefs;

    -- People
    if (Epidemy.radiation == 0) then
        tmp = math.floor(math.random(2));
        People.born = People.born + math.floor (People.now * (0.1 + Science.people/50)) + tmp - 2;
        tmp = math.random();
        if ((People.born<1) and (tmp>0.25)) then
            People.born = 1;
        end
        if (People.born < 0) then
            People.born = 0;
        end
    else
        People.born = 0;
    end
    if (Yoke > 35) then
        tmp = math.random (500);
        People.suicide = math.floor (People.now * Yoke / (500 + tmp + Science.people * 50));
    end
    People.now = People.now + People.balance;
    People.now = People.now + People.born;
    People.now = People.now - People.illness;
    People.now = People.now - People.thiefs;
    People.now = People.now - People.suicide;

    Statistics.people_born = Statistics.people_born + People.born;

-- ========== newyear END =======
end






function ShowGameEnd ()
    tmp = math.random();
    if (Yoke>95) or ((Yoke>80) and (tmp > (0.75+Science.people/100))) then
        GameOverText = 1;
    end
    if (People.now < 4) then
        GameOverText = 2;
    end
    if (not LongLife) and (Year > 70) then
        GameOverText = 3;
    end
    if (Year > 100) then
        GameOverText = 4;
    end
    if (MegaMonster == 666) then
        GameOverText = 5;
    end
    if (GameOverText == 0) then
        return false;
    else
        return true;
    end
end;




Game_Over = room {
    nam = function (s)
        if (GameOverText == 4) then
            return 'Game over!';
        else
            return 'You win the game!';
        end
    end,
    pic = function (s)
        if (GameOverText == 1) then
            return 'images/rebellion.png';
        end
        if (GameOverText == 2) then
            return 'images/game_over_leave.png';
        end
        if (GameOverText == 3) then
            return 'images/game_over_leave.png';
        end
        if (GameOverText == 4) then
            return 'images/title.png';
        end
        if (GameOverText == 5) then
            return 'images/graveyard.png';
        end
    end,
    dsc = function (s)
        if (GameOverText == 1) then
            return '^It is your end, you cruel dictator!^Your people got tired from wars and hunger! You are deposed!';
        end
        if (GameOverText == 2) then
            return '^You have no more nationals!^You and the rest of your people is emigrate to an Argentina...';
        end
        if (GameOverText == 3) then
            return '^You have become weaker with each day and can not rule your kingdom any more.^You have been replaced by younger and healthier candidate.';
        end
        if (GameOverText == 4) then
            return '^Congradulations! You could rule your kingdom during a century!^You successfully deal with your duty!';
        end
        if (GameOverText == 5) then
            return '^Your kingdom have been destroyed by The Darkness Forces...^...and a whole world, though...';
        end
        p ('^^');
        p (txtb('Total years you ruled: '..Year));
        p ('^^');
        p (txtu(txtb('Statistics on a moment of rule ending:')));
        p ('^Population: '..People.now);
        p ('^Grain: '..Corn.now);
        p ('^Kingdim rating: ', Rating, ' points.');
        p ('^Yoke: ', math.floor (Yoke), ' %');
        p ('^Ships: '..Ships.total);
        p ('^');
        p (txtb('Researches:'));
        p ('^      Population: ', Science.people, ' level.');
        p ('^      Land: ', Science.land, ' level.');
        p ('^      Grain: ', Science.corn, ' level.');
        p ('^      Ships: ', Science.ships, ' level.');
        p ('^      Military: ', Science.war, ' level.');
        p ('^      Market: ', Science.buy, ' level.');
        p ('^      Policy: ', Science.policy, ' level.');
        p ('^      Medicine: ', Science.medicine, ' level.');
        p ('^^');
        p (txtu(txtb('Total on all time of ruling:')));

        p ('^^');
        p (txtu(txtb('Population:')));
        p ('^Born: '..Statistics.people_born..' men.');
        p ('^Nomads joined: '..Statistics.nomads..' men.');
        p ('^Died from starvation: '..Statistics.starved_to_death..' men.');
        p ('^Died from disease: '..Statistics.disease..' men.');
        p ('^Given as contribution: '..Statistics.igo_people..' men.');

        p ('^^');
        p (txtu(txtb('Grain:')));
        p ('^Harvest: '..Statistics.harvest..' bushels.');
        p ('^Stolen: '..Statistics.thief_grain..' bushels.');
        p ('^Eaten by rats: '..Statistics.rats..' bushels.');
        p ('^Destroyed by hard rain: '..Statistics.hard_rain..' bushels.');
        p ('^Spoiled by scientists: '..Statistics.grain_spoiled..' bushels.');
        p ('^Lost in unsuccessful deals: '..Statistics.deal_off..' bushels.');
        p ('^Buyed on found artefacts: '..Statistics.artefacts..' bushels.');
        p ('^Synthesized artificial grain: '..Statistics.artificial_grain..' bushels.');
        p ('^Spend on science: '..Statistics.science_spend..' bushels.');
        p ('^Payed as a contribution: '..Statistics.igo_grain..' bushels.');

        p ('^^');
        p (txtu(txtb('Land:')));
        p ('^Buyed: '..Statistics.land_purchased..' acres.');
        p ('^Sold: '..Statistics.land_sold..' acres.');
        p ('^Spoiled by scientists: '..Statistics.land_spoiled..' acres.');
        p ('^Made to fertalized: '..Statistics.land_fertalization..' acres.');
        p ('^Payed as contribution: '..Statistics.igo_land..' acres.');

        p ('^^');
        p (txtu(txtb('Miscellaneous:')));
        p ('^Outbreaks of plague: '..Statistics.plague);
        p ('^Outbreaks of plague prevented: '..Statistics.plague_off);
        p ('^Meteorites fall: '..Statistics.meteorites);
        p ('^Outbreak of locust prevented: '..Statistics.locust_remove);
        p ('^Sources of radiation isolated: '..Statistics.radiation_off);
        p ('^Deals enclosed: '..Statistics.deal_number);
    end,
};
