require 'input'
require 'sprites'
require 'object'
require 'para'
require 'xact'
require 'dash'

dofile('types.lua');
dofile('shownews.lua');
dofile('buildsomething.lua');
dofile('buy_and_sell_land.lua');
dofile('eat.lua');
dofile('sow.lua');
dofile('science.lua');
dofile('port.lua');
dofile('showinventions.lua');
dofile('checkforwar.lua');
dofile('war.lua');

game.codepage="UTF-8"
game.dsc = [[Команды:^
    look(или просто ввод), act <на что> (или просто на что), use <что> [на что], go <куда>,^
    back, inv, way, obj, quit, save <fname>, load <fname>. Работает автодополнение по табуляции.^^]];


function init()
    cur = sprite.load('images/cursor.gif');
    local w,h = sprite.size(cur);
    local yy = sprite.font_scaled_size(h);
    cur2 = sprite.scale(cur, 1, yy/h);
    sprite.free(cur);
    cur = cur2;
    input.cursor=img(cur);
end

vvod = inp('inp', 'Введите число: ', '');



main = room {
    nam = '«Королевство Зерна»',
    pic = 'images/title.png',
    enter = function (s)
        set_music('music/ballada.mod');
    end,
    dsc = function (s)
        p 'Данная игра является одной из самых первых (а, возможно, и самой первой) экономической компьютерной игрой. Первая версия игры называлась «The Sumer Game». Её написал Дуг Даймент в 1968 году на языке FOCAL на DEC PDP-8.^В последствии, Дэвид Х. Ал расширил возможности игры, реализовав её на языке BASIC. Он назвал игру «Hammurabi». Исходный код игры он опубликовал в издании «BASIC Computer Games».^В дальнейшем игра переживала ещё несколько реинкарнаций. Одной из них была игра «Kingdom of Grain» («Королевство Зерна») для ZX Spectrum (1992 год).^В 2005-2008 годах Парфёнов Алексей (alkatrazstudio@yandex.ru), основываясь на коде игры «Hammurabi», написал игру «Kingdom 3» на языке Pascal, ещё более расширив возможности игры. Исходный код был выпущен им под GPL.^Вашему вниманию предлагается очередная версия игры. Исходный код взят из версии Парфёнова Алексея. Картинки взяты из ZX Spectrum версии игры (художник — Белоусов Александр).^Музыка — ballada, автор xtd / union (cia).';
        p '^^Портирование на INSTEAD: Вадим В. Балашов';
        p '^Версия 0.9.3 beta (31.08.2012).^Отзывы направляйте по адресу vvb.backup@rambler.ru';
    end,
    obj = { --vway("1", "{Об авторах}^", 'about'),
            vway('2', '{Инструкция}^', 'instruction'),
            vway('4', '{НАЧАТЬ ИГРУ}', 'initialization') },
};


instruction = room {
    nam = 'Инструкция',
--    pic = 'images/instructions.png',
--    enter = function (s)
--        set_music('music/instructions.ogg');
--    end,
    dsc = function(s)
        return 'Игра сделана целиком на русском языке, поэтому подробных пояснений к ней не требуется. Достаточно читать выводимые на экран вопросы и, опираясь на логику и свой жизненный опыт, давать ответы.^^Вы являетесь монархом древней аграрной страны где-то в центре Европы.^Земли королевства плодородны, крестьяне счастливы, да вот беда: соседи, как всегда, завистливы. Но, несмотря на это, Вы должны обеспечить процветание своей страны и даже попытаться расширить свои владения.^Эта задача не так легка, как может показаться на первый взгляд, ведь против Вас действует изощрённая компьютерная программа. Она насылает на королевство всевозможные напасти: от холеры и чумы до нашествия саранчи и крыс. Да и враги не теряют зря времени, пытаясь отхватить то один, то другой кусочек ваших владений.^В Вашем распоряжении три показателя, которыми можно распоряжаться в зависимости от ситуации: население, земля и зерно. Например, чтобы защититься от врагов, можно воспользоваться услугами наёмников, но им надо чем то платить.^Вот и решайте: то ли отдать часть зерна и заставить голодать своих подданных, то ли уплатить землей, что в конце концов тоже грозит недобором зерна и голодом.^Вот и приходится королю постоянно лавировать между желаемым и возможным, не забывая о том, что при любых обстоятельствах надо сохранить корону, а иначе...';
    end,
    obj = { vway('1', '{Вернуться в главное меню}', 'main') },
};


initialization = room {
    nam = 'Добро пожаловать в Королевство Зерна!',
--    pic = 'images/title.png',
    enter = function (s)
--        Initialization
          Year = 0;
          LongLife = false;
          isScience = false;
          isPort = false;
          isPortShow = false;
          People.total = 100;
          Corn.total = 10000;
          Corn.yield = 5;
          Land.total = 1000;
          People.now = 100;
          Corn.now = Corn.total;
          Corn.yield = 5;
          Land.now = Land.total;
          MegaMonster = 128;
    end,
    dsc = function (s)
        return 'На пышной церемонии коронации Вам поручено было произнести клятву:^^«Я, нижеподписавшийся Король обязуюсь выполнять следующие обязательства:^- Руководить своим королевством только в трезвом виде;^- В случае войны беречь людей,^- Каждому по возможностям, с каждого по потребностям;^...»^Дальше шли несколько строчек мелким шрифтом, но вам так хотелось побыстрее усесться на трон, что Вы подписались не глядя...^^Ну что же, приступим!';
    end,
    obj = { vway('1', '{Далее}', 'main_cycle') },
--    obj = { vway('1', '{Далее}', 'ShowNews') },
};


-- instead version: room sequences
-- ===============================
-- main_cycle
-- ShowBuyLandDialog
-- ShowSellLandDialog
-- ShowEatDialog
-- ShowSowDialog
-- ShowScienceDialog
-- ShowShipBuildDialog
-- ShowPortDialog
-- ShowNews
--   ShowNewsDeal
--   ShowNewsIgo
-- ShowNewInventions
-- CheckForWar
--   ShowPeaceTalkDialog
--     ShowWarDeclareDialog
--       ShowWarDeclareDialog_2
--     GoWar
--     ...
--       EndWar
-- BuildSomething_Sow
-- BuildSomething_Science
-- BuildSomething_Port
-- BuildSomething_Buy_Elixir
-- BuildSomething_Tower
--


main_cycle = room {
--    nam = '«KoG» Main Cycle',
    nam = function (s)
        p ('Год '..Year..'. Результаты года.');
    end,
--    pic = function (s)
--        return 'images/main.png';
--    end,
    enter = function (s)
        NewYear ();
        if ( ShowGameEnd() ) then
            pclr();
            walk (Game_Over);
            return;
        end
    end,
    dsc = function (s)
--        return 'main_cycle';
--====main_cycle====
--  repeat
        pn (imgr 'images/main.png');
        --Отчёт о населении
        p ('^Население на начало года: ', People.total, ' человек.');
        p ('^Родилось: ', People.born, ' человек.');
        p ('^Умерло от голода: ', People.hunger, ' человек.');
        p ('^Умерло от болезней: ', People.illness, ' человек.');
        p ('^Погибло в боях: ', People.war, ' человек.');
        p ('^Самоубийц: ', People.suicide, ' человек.');
        p ('^В результате воровства: ', People.thiefs, ' человек.');
        p ('^В порту: ', People.port, ' человек.');
        p ('^В плавании: ', People.sail, ' человек.');
        p ('^Миграции: ', People.balance, ' человек.');
        p ('^Итого население: ', People.now, ' человек.');

        --Отчёт о земле
        p ('^^Земля на начало года: ', Land.total, ' акров.');
        p ('^Куплено/продано: ', Land.corn, ' акров.');
        p ('^В результате войны: ', Land.war, ' акров.');
        p ('^В результате воровства: ', Land.thiefs, ' акров.');
        p ('^Испорчено: ', Land.spoiled, ' акров.');
        p ('^Присоединено: ', Land.bonus, ' акров.');
        p ('^Итого земли: ', Land.now, ' акров.');

        --Отчёт о зерне
        p ('^^Зерно на начало года: ', Corn.total, ' бушелей.');
        p ('^Пошло на семена: ', Corn.seed, ' бушелей.');
        p ('^Урожай: ', Corn.harvest, ' бушелей.');
        if (Corn.land >= 0) then
            p ('^Выручено при продаже земли: ', Corn.land, ' бушелей.');
        else
            p ('^Уплачено при покупке земли: ', Corn.land, ' бушелей.');
        end
        p ('^На постройку кораблей: ', Corn.ships, ' бушелей.');
        p ('^Пошло на еду: ', Corn.food, ' бушелей.');
        p ('^В результате войны: ', Corn.war, ' бушелей.');
        p ('^В результате воровства: ', Corn.thiefs, ' бушелей.');
        p ('^Съедено крысами: ', Corn.rats, ' бушелей.');
        p ('^В уплату наёмникам: ', Corn.fee, ' бушелей.');
        p ('^В уплату учёным: ', Corn.science, ' бушелей.');
        p ('^Испорчено: ', Corn.spoiled, ' бушелей.');
        p ('^Приобретено: ', Corn.bonus, ' бушелей.');
        p ('^Расход/прибыль со сделки: ', Corn.deal, ' бушелей.');
        p ('^Планируемая урожайность: ', Corn.yield, ' бушель/акр.');
        p ('^Итого зерна: ', Corn.now, ' бушелей.');

        --Отчёт о кораблях
        if isPort then
            p ('^^Корабли: ', Ships.total, ' кораблей.');
            p ('^Построено: ', Ships.build, ' кораблей.');
            p ('^В результате войны: ', Ships.war, ' кораблей.');
            p ('^В плавании: ', Ships.sail, ' кораблей.');
            p ('^Прибыло/отбыло: ', Ships.port, ' кораблей.');
            p ('^Итого кораблей: ', Ships.now, ' кораблей.');
        end

        --Отчёт об исследованиях
        if isScience then
            p ('^^Исследования:');
            p ('^Население: ', Science.people, ' уровень.');
            p ('^Земля: ', Science.land, ' уровень.');
            p ('^Зерно: ', Science.corn, ' уровень.');
            p ('^Корабли: ', Science.ships, ' уровень.');
            p ('^Военное дело: ', Science.war, ' уровень.');
            p ('^Рынок: ', Science.buy, ' уровень.');
            p ('^Политика: ', Science.policy, ' уровень.');
            p ('^Медицина: ', Science.medicine, ' уровень.');
        end

        --Остальная информация
        p ('^^Внешняя/внутренняя политика:');
        p ('^Рейтинг государства: ', Rating, ' пунктов.');
        p ('^Гнёт: ', math.floor (Yoke), ' %');

        --Эпидемии
        if ( (Epidemy.bugs>0) or (Epidemy.radiation>0) or (Epidemy.plague>0) or (Epidemy.igo>0) ) then
            p ('^^Эпидемии:');
        end
        if (Epidemy.bugs > 0) then
            p ('^Нашествие саранчи. Лет до окончания: ', Epidemy.bugs);
        end
        if (Epidemy.radiation > 0) then
            p ('^Радиационный фон. Лет до окончания: ', Epidemy.radiation);
        end
        if (Epidemy.plague > 0) then
            p ('^Чума. Лет до окончания: ', Epidemy.plague);
        end
        if (Epidemy.igo > 0) then
            p ('^Выплата дани: Лет до окончания: ', Epidemy.igo);
        end

        events = 0;
        --Рекомендации
        p ('^^Рекомендации:');
        if ( (isScience) and ( Science.count < 50) ) then
            p ('^Тратьте больше зерна на исследования.');
            events = events + 1;
        end
        if ( (isPort) and ((Ships.sail + Ships.now) < 70) ) then
            p ('^Стройте больше кораблей.');
            events = events + 1;
        end
        if ( (Year > 35) and (People.now < (Year*2.5) ) ) then
            p ('^Повышайте численность населения.');
            events = events + 1;
        end
        if ( (math.floor(Land.now) < People.now*5) ) then
            p ('^Купите землю. Людям негде жить!');
            events = events + 1;
        end
        if ( (Year>3) and (not isSow) ) then
            p ('^Научите людей сеять пшеницу!');
            events = events + 1;
            if (Corn.now < 1000) then
                p (' Вам нужно 1000 бушелей зерна для обучения!');
            end
        end
        if ( (Year > 10) and (not isScience)) then
            p ('^Постройте академию!');
            events = events + 1;
            if (Corn.now < 10000) then
                p (' Вам нужно 10000 бушелей зерна для строительства!');
            end
        end
        if ( (Year > 25) and (not isPort) and (isScience) ) then
            p ('^Постройте порт!');
            events = events + 1;
            if (Corn.now < 50000) then
                p (' Вам нужно 50000 бушелей зерна для строительства!');
            end
        end
        if (Yoke > 60)then
            p ('^Народ на грани революции!');
            events = events + 1;
        end
        if (People.now < 10)then
            p ('^У Вас очень мало населения!');
            events = events + 1;
        end
        if ( (Year > 70) and (not LongLife)) then
            p ('^Купите эликсир долголетия!');
            events = events + 1;
            if (Corn.now < 100000) then
                p (' Вам нужно 100000 бушелей зерна для покупки!');
            end
        end
        if (People.hunger > 0) then
            p '^В Вашем королевстве люди умирают от голода! Выделяйте больше зерна для питания!';
            events = events + 1;
        end
        if (events == 0) then
            p '^На текущий год Ваш стиль управления королевством не вызывает нареканий. Продолжайте в таком же духе!';
        end
    end,
    obj = { vway('1', '{Далее}', 'ShowBuyLandDialog') },
    exit = function (s)
        Statistics.starved_to_death = Statistics.starved_to_death + People.hunger;
        People.born = 0;
        People.hunger = 0;
        People.illness = 0;
        People.suicide = 0;
        People.war = 0;
        People.thiefs = 0;
        People.port = 0;
        People.balance = 0;
        People.total = People.now;
        Land.corn = 0;
        Land.war = 0;
        Land.thiefs = 0;
        Land.spoiled = 0;
        Land.bonus = 0;
        Land.total = Land.now;
        Corn.seed = 0;
        Corn.harvest = 0;
        Corn.land = 0;
        Corn.ships = 0;
        Corn.food = 0;
        Corn.war = 0;
        Corn.thiefs = 0;
        Corn.rats = 0;
        Corn.fee = 0;
        Corn.science = 0;
        Corn.spoiled = 0;
        Corn.bonus = 0;
        Corn.deal = 0;
        Corn.total = Corn.now;
        Ships.build = 0;
        Ships.war = 0;
        Ships.port = 0;
        Ships.total = Ships.now;
    end,
};





function NewYear ()
-- ========== NewYear ===========
    Year = Year + 1;
--    Statistic counting
    if (Epidemy.plague > 0) then
        Epidemy.plague = Epidemy.plague - 1;
    end

    -- Corn
    if (Epidemy.bugs == 0) then
        tmp = math.random (3);
        Corn.yield = tmp + 2 + math.floor (Science.land/3);
    else
        Corn.yield = 0;
    end
    if not isSow then
        Corn.yield = 0;
    end
    Corn.now = Corn.now + Corn.harvest;
    Corn.now = Corn.now + Corn.bonus;
    Corn.now = Corn.now - Corn.rats;
    Corn.now = Corn.now - Corn.spoiled;
    Corn.now = Corn.now - Corn.thiefs;


    tmp = math.random (25);
    Science.integrity = Science.integrity - tmp;
    tmp = math.random (10);
    Yoke = Yoke + tmp - 5;
    if (Yoke < 0) then
        Yoke = 0;
    end
    if (Year > 10) then
        Rating = math.floor (People.now/(Year*2.5)+(Land.now*27+Corn.now)/(Year*100)+(Ships.port+Ships.sail)/(Year/10)+(Science.count)/(Year*0.8));
    else
        Rating = 0;
    end

    -- Land
    Land.now = Land.now + Land.bonus;
    Land.now = Land.now - Land.spoiled;
    Land.now = Land.now - Land.thiefs;

    -- People
    if (Epidemy.radiation == 0) then
        tmp = math.floor(math.random(2));
        People.born = People.born + math.floor (People.now * (0.1 + Science.people/50)) + tmp - 2;
        tmp = math.random();
        if ((People.born<1) and (tmp>0.25)) then
            People.born = 1;
        end
        if (People.born < 0) then
            People.born = 0;
        end
    else
        People.born = 0;
    end
    if (Yoke > 35) then
        tmp = math.random (500);
        People.suicide = math.floor (People.now * Yoke / (500 + tmp + Science.people * 50));
    end
    People.now = People.now + People.balance;
    People.now = People.now + People.born;
    People.now = People.now - People.illness;
    People.now = People.now - People.thiefs;
    People.now = People.now - People.suicide;

    Statistics.people_born = Statistics.people_born + People.born;

-- ========== newyear END =======
end






function ShowGameEnd ()
    tmp = math.random();
    if (Yoke>95) or ((Yoke>80) and (tmp > (0.75+Science.people/100))) then
        GameOverText = 1;
    end
    if (People.now < 4) then
        GameOverText = 2;
    end
    if (not LongLife) and (Year > 70) then
        GameOverText = 3;
    end
    if (Year > 100) then
        GameOverText = 4;
    end
    if (MegaMonster == 666) then
        GameOverText = 5;
    end
    if (GameOverText == 0) then
        return false;
    else
        return true;
    end
end;




Game_Over = room {
    nam = function (s)
        if (GameOverText == 4) then
            return 'ИГРА ПРОЙДЕНА!';
        else
            return 'ИГРА ПРОВАЛЕНА!';
        end
    end,
    pic = function (s)
        if (GameOverText == 1) then
            return 'images/rebellion.png';
        end
        if (GameOverText == 2) then
            return 'images/game_over_leave.png';
        end
        if (GameOverText == 3) then
            return 'images/game_over_leave.png';
        end
        if (GameOverText == 4) then
            return 'images/title.png';
        end
        if (GameOverText == 5) then
            return 'images/graveyard.png';
        end
    end,
    dsc = function (s)
        if (GameOverText == 1) then
            p '^Вам пришёл конец, жестокий диктатор!^Народ устал от войны и голода! Вы низложены!';
        end
        if (GameOverText == 2) then
            p '^У вас совсем не осталось подданных!^Вы и остаток вашего народа эмигрируете в Аргентину...';
        end
        if (GameOverText == 3) then
            p '^Вы слабели с каждым днём и уже не могли управлять королевством.^Ваше место занял более здоровый кандидат.';
        end
        if (GameOverText == 4) then
            p '^Поздравляем! Вы смогли управлять страной в течение века!^Вы успешно справились со своими обязанностями!';
        end
        if (GameOverText == 5) then
            p '^Ваше королевство было уничтожено силами Тьмы...^...впрочем, как и весь остальной мир...';
        end
        p ('^^');
        p (txtb('Итого Вы правили лет: '..Year));
        p ('^^');
        p (txtu(txtb('Статистика на момент окончания правления:')));
        p ('^Население: '..People.now);
        p ('^Зерно: '..Corn.now);
        p ('^Рейтинг государства: ', Rating, ' пунктов.');
        p ('^Гнёт: ', math.floor (Yoke), ' %');
        p ('^Корабли: '..Ships.total);
        p ('^');
        p (txtb('Исследования:'));
        p ('^      Население: ', Science.people, ' уровень.');
        p ('^      Земля: ', Science.land, ' уровень.');
        p ('^      Зерно: ', Science.corn, ' уровень.');
        p ('^      Корабли: ', Science.ships, ' уровень.');
        p ('^      Военное дело: ', Science.war, ' уровень.');
        p ('^      Рынок: ', Science.buy, ' уровень.');
        p ('^      Политика: ', Science.policy, ' уровень.');
        p ('^      Медицина: ', Science.medicine, ' уровень.');
        p ('^^');
        p (txtu(txtb('Итого за всё время правления:')));

        p ('^^');
        p (txtu(txtb('Население:')));
        p ('^Родилось: '..Statistics.people_born..' человек.');
        p ('^Примкнуло кочевников: '..Statistics.nomads..' человек.');
        p ('^Умерло от голода: '..Statistics.starved_to_death..' человек.');
        p ('^Умерло от болезней: '..Statistics.disease..' человек.');
        p ('^Отдано в качестве дани: '..Statistics.igo_people..' человек.');

        p ('^^');
        p (txtu(txtb('Зерно:')));
        p ('^Выращено: '..Statistics.harvest..' бушелей.');
        p ('^Украдено: '..Statistics.thief_grain..' бушелей.');
        p ('^Съедено крысами: '..Statistics.rats..' бушелей.');
        p ('^Уничтожено градом: '..Statistics.hard_rain..' бушелей.');
        p ('^Испорчено учёными: '..Statistics.grain_spoiled..' бушелей.');
        p ('^Потеряно в неудачных сделках: '..Statistics.deal_off..' бушелей.');
        p ('^В результате археологических раскопок выручено: '..Statistics.artefacts..' бушелей.');
        p ('^Искусственного зерна синтезировано: '..Statistics.artificial_grain..' бушелей.');
        p ('^Потрачено на науку: '..Statistics.science_spend..' бушелей.');
        p ('^Отдано в качестве дани: '..Statistics.igo_grain..' бушелей.');

        p ('^^');
        p (txtu(txtb('Земля:')));
        p ('^Куплено: '..Statistics.land_purchased..' акров.');
        p ('^Продано: '..Statistics.land_sold..' акров.');
        p ('^Испорчено учёными: '..Statistics.land_spoiled..' акров.');
        p ('^Сделано плодородными: '..Statistics.land_fertalization..' акров.');
        p ('^Отдано в качестве дани: '..Statistics.igo_land..' акров.');

        p ('^^');
        p (txtu(txtb('Разное:')));
        p ('^Вспышек чумы: '..Statistics.plague);
        p ('^Вспышек чумы предотвращено: '..Statistics.plague_off);
        p ('^Метеоритов упало: '..Statistics.meteorites);
        p ('^Нашествий саранчи предотвращено: '..Statistics.locust_remove);
        p ('^Источников радиации изолировано: '..Statistics.radiation_off);
        p ('^Сделок заключено: '..Statistics.deal_number);
    end,
};
